
bool createFilename() {
  int i = 0;
  bool duplicateID = 1;
  int positionCursor = 0;
  char nameF[9] = "";
  char name_with_extension[13] = "";

  while (duplicateID == 1){
  delay(150);
  lcd.clear();
  lcd.print(availableChar);
  lcd.setCursor(0, 1);
  lcd.print(fileNameResult);
  lcd.setCursor(0, 0);
  lcd.blink();

    while (i < 8) {
      digitalWrite(minusLed,HIGH);
      digitalWrite(plusLed,HIGH);
      digitalWrite(validateLed,HIGH);
      if (digitalRead(minusBtn) == LOW) {
        if ((positionCursor - 1) >= 0)
          positionCursor--;
        lcd.setCursor(positionCursor, 0);
        delay(300);
      }
      else if (digitalRead(plusBtn) == LOW) {
        if ((positionCursor + 1) <= 11)
          positionCursor++;
        lcd.setCursor(positionCursor, 0);
        delay(300);
      }
      else if (digitalRead(validateBtn) == LOW) {
        if (positionCursor <= 9)
          nameF[i] = (char)positionCursor + 48;
        else if (positionCursor == 10)
          nameF[i] = '-';
        else if (i > 0 && positionCursor == 11)
          i = 8;
        if (positionCursor != 11)
          i++;
        lcd.setCursor(0, 1);
        lcd.print(nameF);
        lcd.setCursor(positionCursor, 0);
        delay(300);

      }
      delay(300);
             
    }

    strcpy(name_with_extension, nameF); /* copy name into the new var */
    strcat(name_with_extension, ".CSV"); /* add the extension */
    
    if(duplicateIDSearch(String(name_with_extension))){
      memset(nameF,0,sizeof(nameF));
      duplicateID=1;
      i=0;
      lcdDisplay(filenameAlUsed,filenameAlUsed2);
      digitalWrite(validateLed, HIGH);
      delay(2000);
      lcd.clear();
      
    }
    else{
      duplicateID=0;
    }
  } 

  digitalWrite(minusLed,LOW);
  digitalWrite(plusLed,LOW);
  digitalWrite(validateLed,LOW);
  lcd.noBlink();
  sprintf(filename, "%s.csv", nameF);
  lcdDisplay("Filename : ", filename);
  digitalWrite(validateLed, LOW);
  delay(150);
  checkBtn(validateBtn, false);
  return true;
}

bool checkMemory() {
  int i = 0;
  File root;
  
  lcdDisplay(pleaseWaitMsg, NULL);
  root = SD.open("/");
  while (true) {
    File entry =  root.openNextFile();
    if (!entry)
      break;
    entry.close();
    i++;
  }
  if (i >= 511)
    return false;
  return true;
}

bool duplicateIDSearch( String fileName){
  File entry;
  File root = SD.open("/");
  File dir = root;
  while (true) {
    entry =  dir.openNextFile();
    if (! entry) {

      // no more files that means no duplicate name
      return(0);
    }
    if (fileName == String(entry.name())){
      return(1);

    }
  }
  entry.close();
}
    


void cardErrorHandler(const char *msg, bool f) {
  lcdDisplay(cardErrorMsg, msg);
  delay(3000);
  lcdDisplay(rebootMsg, rebootMsg2);
  checkBtn(validateBtn, false);
  if (f)
    sdModuleConf();
}

