void initBtn() {
  Serial.begin(9600);
  pinMode(minusBtn, INPUT_PULLUP);
  pinMode(plusBtn, INPUT_PULLUP);
  pinMode(validateBtn, INPUT_PULLUP);
  pinMode(clickBtn1, INPUT_PULLUP);
  pinMode(clickBtn2, INPUT_PULLUP);
  pinMode(minusLed, OUTPUT);
  pinMode(plusLed, OUTPUT);
  pinMode(validateLed, OUTPUT);
  pinMode(clickLed1, OUTPUT);
  pinMode(clickLed2, OUTPUT);

  pinMode(photoInt1, INPUT);
  pinMode(photoInt2, INPUT);
  pinMode(photoInt3, INPUT);
  pinMode(photoInt4, INPUT);
  pinMode(photoInt5, INPUT);
  pinMode(photoInt6, INPUT);
  pinMode(photoInt7, INPUT);
  pinMode(photoInt8, INPUT);
  pinMode(photoInt9, INPUT);
  pinMode(clickBtn1GND,OUTPUT);
  digitalWrite(clickBtn1GND,LOW);
  pinMode(clickBtn2GND,OUTPUT);
  digitalWrite(clickBtn2GND,LOW);
  
  
  lcd.begin(16, 2);
}

void displayWelcomeMsg() {
  lcdDisplay(welcomeMsg,welcomeMsg2);
  delay(750);/*
  for (int i = minusLed; i <= validateLed; i++) {
    digitalWrite(i+1, HIGH);
    delay(250);
  }
  delay(500);
  for (int i = minusLed; i <= validateLed; i++)
    digitalWrite(i+1, LOW);*/
  delay(1700);
  lcdDisplay(initDevice, initDevice2);
}

void sdModuleConf() {
  if (!SD.begin(4))
    cardErrorHandler(missingSdCard, true);
}

int getAge() {
  int age = 40;

  delay(400);
  lcdDisplay(patientAge, NULL);
digitalWrite(minusLed,HIGH);
digitalWrite(plusLed,HIGH);
digitalWrite(validateLed,HIGH);
  while (run) {
    if (digitalRead(minusBtn) == LOW && (age > 0))
      age--;
    else if (digitalRead(plusBtn) == LOW && (age < 120))
      age++;
    lcd.setCursor(0, 1);
    lcd.print(age);
    lcd.print(" ");
    if (digitalRead(validateBtn) == LOW) {
      digitalWrite(minusLed,LOW);
      digitalWrite(plusLed,LOW);
      digitalWrite(validateLed,LOW);
      return (age);
    }
    delay(100);
  }
}

bool testBegin(const char *test) {
  lcdDisplay(testInstruction, test);
  delay(750);
  digitalWrite(validateLed, LOW);
  checkBtn(validateBtn, false);
  return true;
}
