void clickTest() {
  int ARCounter = 0;
  unsigned long base = 0;
  long oldTime = 0;

  digitalWrite(validateLed, LOW);
  delay(400);
  lcd.clear();
  resultatClickTest = 0;
  lcd.print(doneMsg);
  for (int i = 0; i < 19; i++)
    clickTabTimes[i] = 0;
  clickTestGTime = false;
  while (run) {
    lcd.setCursor(0,1);
    lcd.print(ARCounter/2);
    lcd.print("/10");
         if (digitalRead(minusBtn) == LOW && digitalRead(plusBtn) == LOW)
      clickTest();
    if (ARCounter % 2 == 0) {
      run = checkBtn(clickBtn1, true);
      if (ARCounter == 0) {
        base = millis();
        oldTime = millis();
      }
      else if (ARCounter > 0 && ARCounter < 20) {
       clickTabTimes[ARCounter-1] = millis() - oldTime;
       oldTime = millis();
      }      
    }
    else {
      run = checkBtn(clickBtn2, true);
      if (ARCounter < 20) {
        clickTabTimes[ARCounter-1] = millis() - oldTime;
        oldTime = millis();
      }
    }
    ARCounter++;
    if (ARCounter == 20) {
      resultatClickTest = millis() - base;
      clickTestGTime = true;
    }
  }
  run = true;
  if (resultatClickTest == 0)
    resultatClickTest = millis() - base;
  displayResult(resultatClickTest);
  digitalWrite(validateLed, HIGH);
  delay(400);
  checkBtn(validateBtn, false);
  if (restartCurrentTest())
    clickTest();
  return;
}

void holes() {
  unsigned long resultat = 0;
  unsigned long baseF = 0;
  long oldTime;

  digitalWrite(validateLed, LOW);
  delay(400);
  cleanVariable();
  lcd.clear();
  lcdDisplay(doneMsg, "0");
  while (holesCounter < 9) {
    if (updateMux1()) {
      if (holesCounter == 0) {
        oldTime = millis();
        baseF = millis();
      }
      else {
        holesTabTimes[holesCounter-1] = (millis() - oldTime);
        oldTime = millis();
      }
      holesCounter++;
      lcd.setCursor(0,1);
      lcd.print(holesCounter);
    }
    delay(150);
  }
  resultatHoles = (millis() - baseF);
  for (int i = 0; i < 9; i++)
    Serial.println(Mux1_Order[i]);
  displayResult(resultatHoles);
  digitalWrite(validateLed, HIGH);
  delay(400);
  checkBtn(validateBtn, false);
  if (restartCurrentTest())
    holes();
  return;
}
